! Example 2 of the course "Practical MPI for Novices".
! It shows that calculation can be parallelized.
! HPCVL, Queen's University, 2006

MODULE MPI
  INCLUDE 'mpif.h'
  INTEGER::MYID,TOTPS, IERR
END MODULE MPI


PROGRAM EXAMPLE02
  USE   MPI
  CALL  MPIINIT
  CALL  DEMO02
  CALL  MPI_FINALIZE(IERR)
  STOP
END PROGRAM EXAMPLE02


SUBROUTINE MPIINIT
  USE  MPI
  CALL MPI_INIT( IERR )
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYID,IERR)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,TOTPS,IERR)
  RETURN
END SUBROUTINE MPIINIT


SUBROUTINE DEMO02
  USE MPI
  INTEGER:: M, I
  REAL*8 :: S, MYS, T1, T2
  IF(MYID.EQ.0) THEN
     CALL CPU_TIME(T1)
     WRITE(*,*)'How many terms?'
     READ(*,*) M
  END IF
  CALL MPI_BCAST(M,1,MPI_INTEGER,0, & 
                 MPI_COMM_WORLD,IERR)
  MYS=0.0D0
  DO I=MYID,M,TOTPS
     MYS=MYS+DSQRT(DFLOAT(I))
  END DO
  WRITE(*,*)'RANK:', MYID,'MYS=',MYS,' M:',M
  S=0.0D0
  CALL MPI_REDUCE(MYS,S,1,MPI_REAL8,MPI_SUM, &
                       0, MPI_COMM_WORLD,IERR)
  IF(MYID.EQ.0) THEN 
	WRITE(*,*)'Total sum:  ', S
        CALL CPU_TIME(T2)
	WRITE(*,*)'Total time on rank 0:  ', T2-T1
  ENDIF
  RETURN
END SUBROUTINE DEMO02

