! This is an example code to split a  
! communicator into a few smaller ones.
! HPCVL, Queen's University, 2006

MODULE MPI
  INCLUDE 'mpif.h'
  INTEGER::MYID,TOTPS, IERR
END MODULE MPI

MODULE COMMUNICATOR1
  INTEGER:: COMM1,MYID1,TOTPS1
  INTEGER:: NOFCOMM1,NPPERCOMM1
END MODULE COMMUNICATOR1

PROGRAM EXAMPLE22
  USE   MPI
  CALL  MPIINIT
  CALL  DEMO22
  CALL  MPI_FINALIZE(IERR)
  STOP
END PROGRAM EXAMPLE22

SUBROUTINE MPIINIT
  USE  MPI
  CALL MPI_INIT( IERR )
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYID,IERR)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,TOTPS,IERR)
  RETURN
END SUBROUTINE MPIINIT

SUBROUTINE DEMO22
  USE MPI
  USE COMMUNICATOR1
  INTEGER:: MA,MB, M, I

  NOFCOMM1=1
  DO I=2,INT(SQRT(FLOAT(TOTPS)))
     IF(((TOTPS/I)*I).EQ.TOTPS) THEN
        IF(NOFCOMM1.LT.I)NOFCOMM1=I
     END IF
  END DO
  NPPERCOMM1=TOTPS/NOFCOMM1

  CALL MPI_COMM_SPLIT(MPI_COMM_WORLD,   &
         MYID/NPPERCOMM1,MYID,COMM1,IERR)

  CALL MPI_COMM_RANK(COMM1,MYID1,IERR)

  CALL MPI_COMM_SIZE(COMM1,TOTPS1,IERR)

  MA=0
  CALL MPI_ALLREDUCE(MYID,MA,1,         &
                MPI_INTEGER, MPI_SUM,   &
                     MPI_COMM_WORLD,IERR)
  MB=0
  CALL MPI_ALLREDUCE(MYID,MB,1,         &
          MPI_INTEGER,MPI_SUM,COMM1,IERR)

  IF(MYID.EQ.0) WRITE(*,*) ' NewMyID, ',&
              '  MyID,     MB,     MA,',&
                 ' NewTotalPS, TotalPS'

  CALL MPI_BARRIER(MPI_COMM_WORLD,IERR)
  WRITE(*,10)MYID1,MYID,MB,MA,TOTPS1,TOTPS
  10 FORMAT(1X,20I8)

  CALL MPI_COMM_FREE(COMM1,IERR)

  RETURN
END SUBROUTINE DEMO22
