#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <malloc.h>
#include <time.h>
#include "mpi.h"

#define BILLION 1000000000L

void Random(double *array, long array_size, int r);
void initialmpi(int *myid, int *totps, int argc, char **argv);

int rank,size;

int main(int argc,char **argv){

    /* Serial output through MPI_gather() and write on rank 0
       Hartmut Schmider September 2013 */

    FILE * out;
    double *dump, *stuff; 
    struct timespec t1,t2;

    long ndata,nmax,i,j;

    MPI_Init(NULL,NULL);  
    MPI_Comm_rank(MPI_COMM_WORLD,&rank);
    MPI_Comm_size(MPI_COMM_WORLD,&size);

    if(rank==0){
	printf(" How big should the data be ?\n");
	scanf("%ld",&ndata);
	dump=(double *)malloc(ndata*sizeof(double));
        clock_gettime(CLOCK_REALTIME,&t1);
    }

    /* Broadcasting size, loading elements with random numbers */
    MPI_Bcast(&ndata,1,MPI_LONG,0,MPI_COMM_WORLD);
    nmax=ndata/size;
    stuff=(double*)malloc(nmax*sizeof(double));
    Random(stuff,nmax,rank);
    MPI_Barrier(MPI_COMM_WORLD);
    if (rank==0){
        clock_gettime(CLOCK_REALTIME,&t2);
	printf(" Time for loading array = %f\n",(double)(t2.tv_sec-t1.tv_sec)+(double)(t2.tv_nsec-t1.tv_nsec)/BILLION);
    }

    /* Gathering data */
    MPI_Gather(stuff,nmax,MPI_DOUBLE_PRECISION,dump,nmax,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD);
    if (rank==0){
        clock_gettime(CLOCK_REALTIME,&t1);
	printf("Time for communication = %f\n",(double)(t1.tv_sec-t2.tv_sec)+(double)(t1.tv_nsec-t2.tv_nsec)/BILLION);
	/* Dumping data */
	out=fopen("/tmp/c.11","w"); fprintf(out,"%ld\n",ndata); fclose(out);
	out=fopen("/tmp/c.10","w"); fwrite(dump,sizeof(double),ndata,out); fclose(out);
        clock_gettime(CLOCK_REALTIME,&t2);
	printf("Time for dumping data = %f\n",(double)(t2.tv_sec-t1.tv_sec)+(double)(t2.tv_nsec-t1.tv_nsec)/BILLION);
	free(dump);
    }
    free(stuff);
    MPI_Finalize();
    exit(0);
}
