subroutine compute(array,array_size,ave,std,total)

  use mpi
  use mpi_basics

  integer, intent(in) :: array_size,total
  double precision, intent(in) :: array(array_size)
  double precision, intent(out) :: ave,std
  integer :: i
  double precision :: sum

  ! Compute average and standard deviation (parallel)
  sum=0
  ave=0
  std=0
  do i=1,array_size
     sum=sum+array(i)
  end do
  call MPI_reduce(sum,ave,1,MPI_DOUBLE_PRECISION,MPI_SUM,0,MPI_COMM_WORLD,ierr)
  if (rank.eq.0) ave=ave/total
  call MPI_bcast(ave,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
  sum=0
  do i=1,array_size
     sum=sum+(array(i)-ave)**2
  end do
  call MPI_reduce(sum,std,1,MPI_DOUBLE_PRECISION,MPI_SUM,0,MPI_COMM_WORLD,ierr)
  if (rank.eq.0) std=sqrt(std/total)
  return
end subroutine compute

