program parallelI
  ! Pseudo parallel input throughread from separate files
  ! Hartmut Schmider December 2013

  use mpi
  use mpi_basics

  implicit none
  double precision, allocatable :: stuff(:)
  double precision :: t1,t2,sum,average,standard
  integer :: ndata,nmax,i,handle
  integer, dimension(MPI_STATUS_SIZE) :: status
  integer (kind=MPI_OFFSET_KIND) :: offset

  call mpistart

! Read in data
  if(rank.eq.0) then
     read(11,*)nmax
     call cpu_time(t1)
  end if
  call MPI_bcast(nmax,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  offset=rank*8*nmax
  ndata=size*nmax
  allocate(stuff(nmax))
  call MPI_File_open(MPI_COMM_WORLD,"/tmp/fort.10",MPI_MODE_RDONLY,MPI_INFO_NULL,handle,ierr)
  call MPI_File_seek(handle,offset,MPI_SEEK_SET,ierr)
  call MPI_File_read(handle,stuff,nmax,MPI_DOUBLE_PRECISION,status,ierr)
  call MPI_barrier(MPI_COMM_WORLD,ierr)
  call MPI_File_close(handle,ierr)
  if (rank.eq.0) then
     call cpu_time(t2)
     write(*,*)' Time for reading arrays = ',t2-t1,' seconds'
  end if

! Compute average and standard deviation (parallel)
  call compute(stuff,nmax,average,standard,ndata)
  if (rank.eq.0) then
     write(*,*)' Average =',average
     write(*,*)' Standard Deviation = ',standard
     call cpu_time(t1)
     write(*,*)' Time for length computation = ',t1-t2,' seconds'
  end if

! Wrap up  
  deallocate(stuff)
  call MPI_finalize(ierr)
  stop
end program parallelI
