program pseudoI
  ! Pseudo parallel input throughread from separate files
  ! Hartmut Schmider September 2013

  use mpi
  use mpi_basics
  use fname

  implicit none
  double precision, allocatable :: stuff(:)
  double precision :: t1,t2,sum,average,standard
  integer :: ndata,nmax,i

  call mpistart

! Read in data
  if(rank.eq.0) then 
     call cpu_time(t1)
     read(11,*)nmax
  end if
  call MPI_bcast(nmax,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  ndata=size*nmax
  allocate(stuff(nmax))
  open(10,file=filename(rank),form="unformatted")
  read(10)stuff
  close(10)
  call MPI_barrier(MPI_COMM_WORLD,ierr)
  if (rank.eq.0) then
     call cpu_time(t2)
     write(*,*)' Time for reading arrays = ',t2-t1,' seconds'
  end if

! Compute average and standard deviation (parallel)
  call compute(stuff,nmax,average,standard,ndata)
  if (rank.eq.0) then
     write(*,*)' Average =',average
     write(*,*)' Standard Deviation = ',standard
     call cpu_time(t1)
     write(*,*)' Time for length computation = ',t1-t2,' seconds'
  end if
! Wrapping up  
  deallocate(stuff)
  call MPI_finalize(ierr)
  stop
end program pseudoI
