program pseudoO
  ! Pseudo-Parallel output, each process to its own file
  ! Hartmut Schmider September 2013

  use mpi
  use mpi_basics
  use fname

  implicit none
  double precision, allocatable :: stuff(:)
  double precision :: t1,t2
  integer :: ndata,nmax,i,j,ransize
  integer, allocatable :: seed(:)
  
  call mpistart

  if(rank.eq.0)then
     write(*,*)' How big should the data be ?'
     read(*,*)ndata
     call cpu_time(t1)
  end if

! Broadcasting size, loading elements with random numbers
  call MPI_bcast(ndata,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  nmax=ndata/size
  allocate(stuff(nmax))
  call random(stuff,nmax,rank)
  if (rank.eq.0) then
     call cpu_time(t2)
     write(*,*)' Time for loading array = ',t2-t1,' seconds'
  end if
  
  ! Dumping data individually per process
  write(11,*)nmax
  open(10,file=filename(rank),form="unformatted")
  write(10)stuff
  close(10)
  call MPI_barrier(MPI_COMM_WORLD,ierr)
  if (rank.eq.0) then
     call cpu_time(t1)
     write(*,*)' Time for dumping data = ',t1-t2,' seconds'
  end if
! Wrapping up  
  deallocate(stuff)
  call MPI_finalize(ierr)
  stop
end program pseudoO

