program serialI
  ! Serial input through read on rank 0 and MPI_Scatter()
  ! Hartmut Schmider September 2013

  use mpi
  use mpi_basics

  implicit none
  double precision, allocatable :: haul(:), stuff(:)
  double precision :: t1,t2,sum,average,standard
  integer :: ndata,nmax,i

  call mpistart

! Read in data
  if(rank.eq.0)then
     read(11,*)ndata
     allocate(haul(ndata))
     call cpu_time(t1)
     open(10,file="/tmp/fort.10",form="unformatted")
     read(10)haul
     close(10)
     call cpu_time(t2)
     write(*,*)' Time for reading array = ',t2-t1,' seconds'
  end if

! Broadcast size, scatter data
  call MPI_bcast(ndata,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  nmax=ndata/size
  allocate(stuff(nmax))
  call MPI_Scatter(haul,nmax,MPI_DOUBLE_PRECISION,stuff,nmax,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
  if (rank.eq.0) then
     call cpu_time(t1)
     write(*,*)' Time for communication = ',t1-t2,' seconds'
  end if

! Computation of avergae and standard deviation
  call compute(stuff,nmax,average,standard,ndata)
  if (rank.eq.0) then
     write(*,*)' Average =',average
     write(*,*)' Standard Deviation = ',standard
     call cpu_time(t2)
     write(*,*)' Time for length computation = ',t2-t1,' seconds'
  end if
     
  ! Wrap up  
  deallocate(stuff)
  call MPI_finalize(ierr)
  stop
end program serialI


