program serialO
  ! Serial output through MPI_gather() and write on rank 0
  ! Hartmut Schmider September 2013

  use mpi
  use mpi_basics

  implicit none
  double precision, allocatable :: dump(:), stuff(:)
  double precision :: t1,t2
  integer :: ndata,nmax,i,j,ransize
  
  call mpistart

  if(rank.eq.0)then
     write(*,*)' How big should the data be ?'
     read(*,*)ndata
     allocate(dump(ndata))
     call cpu_time(t1)
  end if

! Broadcasting size, loading elements with random numbers
  call MPI_bcast(ndata,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  nmax=ndata/size
  allocate(stuff(nmax))
  call random(stuff,nmax,rank)
  call MPI_barrier(MPI_COMM_WORLD,ierr)
  if (rank.eq.0) then
     call cpu_time(t2)
     write(*,*)' Time for loading array = ',t2-t1,' seconds'
  end if
  
! Gathering data
  call MPI_Gather(stuff,nmax,MPI_DOUBLE_PRECISION,dump,nmax,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
  if (rank.eq.0) then
     call cpu_time(t1)
     write(*,*)' Time for communication = ',t1-t2,' seconds'
! Dumping data
     write(11,*)ndata
     open(10,file="/tmp/fort.10",form="unformatted")
     write(10)dump
     close(10)
     call cpu_time(t2)
     write(*,*)' Time for dumping data = ',t2-t1,' seconds'
     deallocate(dump)
  end if

! Wrapping up  
  deallocate(stuff)
  call MPI_finalize(ierr)
  stop
end program serialO
